Summary: emacs lisp for J-Shell.
Name: J-Shell
Version: 2.0
Release: 25AX
URL: ftp://archive.cis.ohio-state.edu/pub/gnu/emacs/elisp-archive/modes/J-Shell-2.0.tar.Z
Source0: J-Shell-%{version}.tar.Z
Source1: j-shell-init.el.emacs
Source2: j-shell-init.el.xemacs
Patch0: J-Shell-%{version}.dot-rc.patch
Patch1: J-Shell-%{version}.j-shell.patch
Patch2: J-Shell-%{version}.dot-cshrc.patch
Patch3: J-Shell-%{version}.dot-bashrc.patch
Patch4: J-Shell.make.patch
License: GPL
Group: Applications/Editors
BuildRoot: %{_tmppath}/%{name}-%{version}-root
BuildRequires: emacs,xemacs

%description
This is Jim's Pretty-Good Shell Mode (J-Shell), a shell-mode for GNU Emacs.

NOTE: Version 2.1 fixes a problem in running J-Shell under FSF
      Emacs version 19.24 and later.  J-Shell 2.1 should also work
      with earlier versions of FSF Emacs 19, Lucid Emacs 19
      (XEmacs), and Emacs 18.

Written and maintained by: Jim Thompson
			   jimt@sugar.neosoft.com

J-Shell is a shell mode derived from Emacs 18's shell mode (although
it has been changed so much that it bears little resemblance to the
original).  J-Shell's features include:

  *  Accurate working-directory tracking

  *  Filename completion

  *  Command completion

  *  Environment variable completion, substitution, and tracking

  *  Host tracking and a simple interface to ange-ftp

  *  A browseable command history stack

  *  Password detection and hiding (with some security features)

  *  Automatic generation of new buffers

  *  Input buffering (a fix for the ^G problem)

J-Shell can be used with most popular shells; the exception is sh, which
cannot be used because it provides no means of aliasing its cd command.
(You *could* use sh with J-Shell, but you would have no directory
tracking.)  Sh users would be better off using the shell-mode that comes
with Emacs.

Note that J-Shell requires that you modify your shell's startup
script so that it can communicate with J-Shell.  This is how J-Shell
achieves its directory and environment variable tracking.  If you
you're not comfortable modifying your startup script, then J-Shell is
probably not for you.

See the file DOC for instructions on using J-Shell

NOTE: To report bugs use the C-c C-b binding.  See file DOC, section BUGS.

%package emacs
Summary: emacs lisp for J-Shell.
Requires: J-Shell
PreReq: emacs
Group: Applications/Editors

%description emacs
This is Jim's Pretty-Good Shell Mode (J-Shell), a shell-mode for GNU Emacs.
This package has been built for emacs.

%package xemacs
Summary: xemacs lisp for J-Shell.
Requires: xemacs, J-Shell
PreReq: xemacs
Group: Applications/Editors

%description xemacs
This is Jim's Pretty-Good Shell Mode (J-Shell), a shell-mode for GNU Emacs.
This package has been built for xemacs.

%prep
%setup -q -n J-Shell-2.0
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1

%build
echo '##### for emacs #####'
rm -f *.elc
sh make.sh emacs
mv j-shell.elc j-shell.elc.emacs

echo '##### for xemacs #####'
rm -f *.elc
perl -pi -e 's/screen-width/window-width/g' j-shell.el
sh make.sh xemacs
mv j-shell.elc j-shell.elc.xemacs

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/usr/share/%{name}-%{version} $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
mkdir -p $RPM_BUILD_ROOT/usr/share/emacs/site-lisp/{site-start.d,J-Shell-%{version}}
mkdir -p $RPM_BUILD_ROOT/usr/share/xemacs/site-packages/lisp/{site-start.d,%{name}-%{version}}

cp -p dot-* $RPM_BUILD_ROOT/usr/share/%{name}-%{version}
cp -p CHANGES DOC LCD-Entry README TO-DO  $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}

cp -p %SOURCE1 $RPM_BUILD_ROOT/usr/share/emacs/site-lisp/site-start.d/j-shell-init.el
cp -p j-shell.el $RPM_BUILD_ROOT/usr/share/emacs/site-lisp/J-Shell-%{version}/j-shell.el
cp -p j-shell.elc.emacs $RPM_BUILD_ROOT/usr/share/emacs/site-lisp/J-Shell-%{version}/j-shell.elc

cp -p %SOURCE2 $RPM_BUILD_ROOT/usr/share/xemacs/site-packages/lisp/site-start.d/j-shell-init.el
cp -p j-shell.el $RPM_BUILD_ROOT/usr/share/xemacs/site-packages/lisp/%{name}-%{version}/j-shell.el
cp -p j-shell.elc.xemacs $RPM_BUILD_ROOT/usr/share/xemacs/site-packages/lisp/%{name}-%{version}/j-shell.elc
%clean
rm -rf $RPM_BUILD_ROOT

%post
if [ -f /etc/bashrc ] ; then
    grep '^#added by J-Shell' /etc/bashrc >/dev/null 2>&1
    if [ $? '!=' 0 ] ; then
	cat <<-EOF >>/etc/bashrc

	# added by J-Shell - DO NOT DELETE THIS LINE
	if [ x\${TERM} = xemacs -a -f /usr/share/J-Shell-2.0/dot-bashrc ] ; then
	    . /usr/share/J-Shell-2.0/dot-bashrc
	fi
	EOF
    fi
fi

%files
%defattr(-,root,root)
%dir /usr/share/%{name}-%{version}
%{_docdir}/%{name}-%{version}

%files emacs
%dir %attr(0755,root,root) /usr/share/emacs/site-lisp/J-Shell-%{version}
%defattr(0644,root,root)
/usr/share/emacs/site-lisp/site-start.d/j-shell-init.el
/usr/share/emacs/site-lisp/J-Shell-%{version}

%files xemacs
%dir %attr(0755,root,root) /usr/share/xemacs/site-packages/lisp/J-Shell-%{version}
%defattr(0644,root,root)
/usr/share/xemacs/site-packages/lisp/site-start.d/j-shell-init.el
/usr/share/xemacs/site-packages/lisp/J-Shell-%{version}

%changelog
* Fri Jun 11 2004 Jun YOSHIDA <jun@miraclelinux.com> 2.0-25AX
- change the directory permissions.

* Fri Jun 4  2004 Jun YOSHIDA <jun@miraclelinux.com> 2.0-24AX
- added PreReq tag.

* Thu May 27 2004 Jun YOSHIDA <jun@miraclelinux.com>
- changed for ML30.

* Wed Aug 29 2001 Jun YOSHIDA <jun@miraclelinux.com>
- Initial build.
